Create an order
Note: This operation is only available if you have the Orders feature enabled. If you are an existing Zuora Subscribe and Amend customer, we recommend you enable Orders Harmonization to access the Orders feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing.
Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
You can use this operation to create subscriptions and make changes to subscriptions by creating orders. You can also use this operation to create order line items by creating orders. The following tutorials demonstrate how to use this operation:
- Create a Subscription
- Add a Product to a Subscription
- Create a Ramp Deal
- Add a Product Mid-Interval Update on a Ramp Deal
- Add a Product in a Ramp Deal
- Change the Terms and Conditions of a Ramp Deal
- Change the Owner of a Subscription
- Change the Terms and Conditions of a Subscription
- Renew a Subscription
- Renew a Subscription and Upgrade a Product
- Replace a Product in a Subscription
- Update a Product in a Subscription
- Cancel a Subscription
- Remove a Product from a Subscription
- Create sales order line items
- Associate order line items with new subscriptions
- Return order line items
You can also use this operation to create orders and save the orders as Scheduled Orders.
In addition, you can use this operation to place a standalone order to subscribe without pre-defining a product catalog in Zuora Billing. For more information, see Create a subscription using a standalone order.
Note: If you received a timeout error message when creating an order, the call is still running in the backend and the order will be created.
The limit of orders allowed on a subscription is 1000.
The limit of order line items allowed in an order is 100.
Zuora has the following limits on the Orders synchronous API to prevent performance degradation:
- Up to 50 subscriptions are allowed in a single Create an order or Preview an order operation call.
- Up to 50 order actions are allowed in a single Create an order or Preview an order operation call.
- Up to 50 order actions are allowed on a single subscription in a Create an order or Preview an order operation call.
If you have an Order that exceeds any limits of the above, Zuora recommends you use the following asynchronous API operations:
- Create an order asynchronously
- Preview an order asynchronously
- Retrieve the status and response of a job for checking the status of the asynchronous API operations
Zuora has the following limits on the Orders asynchronous API operations to prevent performance degradation:
- Up to 300 subscriptions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call.
- Up to 300 order actions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call.
- Up to 300 order actions are allowed on a single subscription in a Create an order asynchronously or Preview an order asynchronously operation call.
Note: When you are to suspend a subcription (via the suspend order action), if in the same “Create an order” call you are to perform other subsequent order actions on the supscription to suspend, you must first resume the subscription (via a resume order action).
Note: When using this operation to create an account, create a subscription, run billing, and collect payment in a single call, if any error occurs during the call, such as a payment processing failure and a tax engine failure, then all the other steps will be rolled back. This means that the invoice will not be generated, the subscription will not be created, and the account will not be created.
Note: The characters #, ?, and / are not allowed in the Orders operations.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Query parameters
Request
Category of the order to indicate a product sale or return. Default value is NewSales.
The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field. If you want to relax the restriction that the existingAccountNumber must be the invoice owner of the subscriptions in this order, submit a request to Zuora Global Support.
Note: You can specify either the existingAccountNumber or existingAccountId field, but not both.
The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field. If you want to relax the restriction that the existingAccountNumber must be the invoice owner of the subscriptions in this order, submit a request to Zuora Global Support.
Order Line Items are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.
With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.
If you do not have the Create Order Line Items Without Product Catalog billing permission, you can only create order line items from existing products by specifying the product rate plan charge ID in the productRatePlanChargeId field. For more information about billing permissions, see Billing Roles.
Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
The order number of the new order. If not provided, system will auto-generate a number for this order.
Note: The characters #, ?, and / are not allowed in this field. Additionally, to ensure compatibility with the UI when viewing orders, use only the following special characters: _,-, ., ~, *, (, ), and '.
The container for billing processing options and payment processing options.
Note:
- This field is not supported in draft orders.
- When you use the “Create an order” operation to create an account, create a subscription, run billing, and collect payment in a single call, if any error occurs during the call, such as a payment processing failure and a tax engine failure, then all the other steps will be rolled back. In this case, neither the invoice will be generated, nor the subscription nor the account will be created.
- When you use the “Create an order” operation to cancel a subscription with
refundandwriteOff, if therefundorwriteOfffails,cancelSubscription,runBilling, andcollectPaymentstill can succeed. - When you use the “Create an order” operation, the
collectPaymentandrefundfields cannot be set totruesimultaneously. Otherwise, the order will not be proceeded.
Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs.
The status of the order. The default value is Completed. The following values are supported:
Draft: The order is in draft status.Pending: The order is in pending status.Completed: The order is in completed status.Scheduled: The order is in scheduled status and it is only valid if the Scheduled Orders feature is enabled.Executing: The scheduled order is executed by a scheduler and it is only valid if the Scheduled Orders feature is enabled.Failed: The scheduled order has failed.
Note: If you have the Pending Subscription Processing feature turned on and want to create a completed order with an active subscription with pending charges, you must specify Completed in this field because the default order status is Pending for this scenario.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
The container of the error code and message. This field is available only if the success field is false.
The account ID for the order. This field is returned instead of the accountNumber field if the returnIds query parameter is set to true.
An array of the credit memo IDs generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled. This field is returned instead of the creditMemoNumbers field if the returnIds query parameter is set to true.
An array of the invoice IDs generated in this order request. Normally it includes one invoice ID only, but can include multiple items when a subscription was tagged as invoice separately. This field is returned instead of the invoiceNumbers field if the returnIds query parameter is set to true.
The ID of the order created. This field is returned instead of the orderNumber field if the returnIds query parameter is set to true.
Order Line Items are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.
With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.
Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
The payment Id that is collected in this order request. This field is returned instead of the paymentNumber field if the returnIds query parameter is set to true.
Note: This field is only available if you have the Ramps feature enabled. The Orders feature must be enabled before you can access the Ramps feature. The Ramps feature is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see Zuora Editions for pricing information coming October 2020.
The ramp definitions created by this order request.
Status of the order. Pending is only applicable for an order that contains a CreateSubscription order action.
Container for the subscription IDs of the subscriptions in an order. This field is returned if the returnIds query parameter is set to true.
Container for write-offs.